Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions

# AsyncTask Class Reference

This class represents a concrete task performed by an AsyncManager. More...

Inheritance diagram for AsyncTask:

List of all members.

## Public Types
enum | DoneStatus { DSDone = 0, DSCont = 1, DSAgain = 2, DSPickup = 3, DSExit = 4, DSPause = 5, DSInterrupt = 6 }
enum | State { SInactive = 0, SActive = 1, SServicing = 2, SServicingRemoved = 3, SSleeping = 4, SActiveNested = 5 }
## Public Member Functions
| clearDelay ()
| Removes any delay specified for the task.
| clearName ()
| Resets the task's name to empty.
double | getAverageDt ()
| Returns the average amount of time elapsed during each of the task's previous run cycles, in seconds.
double | getDelay ()
| Returns the delay value that has been set via set_delay, if any.
string | getDoneEvent ()
| Returns the event name that will be triggered when the task finishes.
double | getDt ()
| Returns the amount of time elapsed during the task's previous run cycle, in seconds.
int | getElapsedFrames ()
| Returns the number of frames that have elapsed since the task was started, according to the task manager's clock.
double | getElapsedTime ()
| Returns the amount of time that has elapsed since the task was started, according to the task manager's clock.
AsyncTaskManager | getManager ()
| Returns the AsyncTaskManager that this task is active on.
double | getMaxDt ()
| Returns the maximum amount of time elapsed during any one of the task's previous run cycles, in seconds.
string | getNamePrefix ()
| Returns the initial part of the name, up to but not including any trailing digits following a hyphen or underscore.
int | getPriority ()
| Returns the task's current priority value.
PyObject | getPythonObject ()
| Returns the Python object that was specified to set_python_object(), if any, or None if no object was specified.
int | getSort ()
| Returns the task's current sort value.
int | getStartFrame ()
| Returns the frame number at which the task was started, according to the task manager's clock.
double | getStartTime ()
| Returns the time at which the task was started, according to the task manager's clock.
State | getState ()
| Returns the current state of the task.
string | getTaskChain ()
| Returns the AsyncTaskChain on which this task will be running.
long int | getTaskId ()
| Returns a number guaranteed to be unique for each different AsyncTask object in the universe.
double | getWakeTime ()
| If this task has been added to an AsyncTaskManager with a delay in effect, this returns the time at which the task is expected to awaken.
bool | hasDelay ()
| Returns true if a delay has been set for this task via set_delay(), or false otherwise.
bool | isAlive ()
| Returns true if the task is currently active or sleeping on some task chain, meaning that it will be executed in its turn, or false if it is not active.
| output (ostream out)
| Outputs the Namable.
| recalcWakeTime ()
| If the task is currently sleeping on a task chain, this resets its wake time to the current time + get_delay().
| remove ()
| Removes the task from its active manager, if any, and makes the state S_inactive (or possible S_servicing_removed).
| setDelay (double delay)
| Specifies the amount of time, in seconds, by which this task will be delayed after it has been added to the AsyncTaskManager.
| setDoneEvent (string done_event)
| Sets the event name that will be triggered when the task finishes.
| setName (string name)
| setPriority (int priority)
| Specifies a priority value for this task.
| setPythonObject (PyObject python_object)
| Specifies an arbitrary Python object that will be piggybacked on the task object.
| setSort (int sort)
| Specifies a sort value for this task.
| setTaskChain (string chain_name)
| Specifies the AsyncTaskChain on which this task will be running.
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

This class represents a concrete task performed by an AsyncManager.

Normally, you would subclass from this class, and override do_task(), to define the functionality you wish to have the task perform.

## Member Enumeration Documentation

enum DoneStatus

Enumerator:

  DSDone |
  DSCont |
  DSAgain |
  DSPickup |
  DSExit |
  DSPause |
  DSInterrupt |

enum State

Enumerator:

  SInactive |
  SActive |
  SServicing |
  SServicingRemoved |
  SSleeping |
  SActiveNested |

## Member Function Documentation

clearDelay | ( |  | ) |

Removes any delay specified for the task.

The next time the task is added to the queue, it will run immediately. This does not affect the task's wake time if it has already been added to the queue.

clearName | ( |  | ) |

Resets the task's name to empty.

Reimplemented from Namable.

double getAverageDt | ( |  | ) |

Returns the average amount of time elapsed during each of the task's previous run cycles, in seconds.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from AsyncTaskBase.

Reimplemented in AnimateVerticesRequest, TextureReloadRequest, AsyncTaskPause, AsyncTaskSequence, PythonTask, BindAnimRequest, ModelLoadRequest, and ModelFlattenRequest.

double getDelay | ( |  | ) |

Returns the delay value that has been set via set_delay, if any.

string getDoneEvent | ( |  | ) |

Returns the event name that will be triggered when the task finishes.

See set_done_event().

double getDt | ( |  | ) |

Returns the amount of time elapsed during the task's previous run cycle, in seconds.

int getElapsedFrames | ( |  | ) |

Returns the number of frames that have elapsed since the task was started, according to the task manager's clock.

It is only valid to call this if the task's status is not S_inactive.

double getElapsedTime | ( |  | ) |

Returns the amount of time that has elapsed since the task was started, according to the task manager's clock.

It is only valid to call this if the task's status is not S_inactive.

AsyncTaskManager getManager | ( |  | ) |

Returns the AsyncTaskManager that this task is active on.

This will be NULL if the state is S_inactive.

double getMaxDt | ( |  | ) |

Returns the maximum amount of time elapsed during any one of the task's previous run cycles, in seconds.

string getNamePrefix | ( |  | ) |

Returns the initial part of the name, up to but not including any trailing digits following a hyphen or underscore.

int getPriority | ( |  | ) |

Returns the task's current priority value.

See set_priority().

PyObject getPythonObject | ( |  | ) |

Returns the Python object that was specified to set_python_object(), if any, or None if no object was specified.

int getSort | ( |  | ) |

Returns the task's current sort value.

See set_sort().

int getStartFrame | ( |  | ) |

Returns the frame number at which the task was started, according to the task manager's clock.

It is only valid to call this if the task's status is not S_inactive.

double getStartTime | ( |  | ) |

Returns the time at which the task was started, according to the task manager's clock.

It is only valid to call this if the task's status is not S_inactive.

State getState | ( |  | ) |

Returns the current state of the task.

string getTaskChain | ( |  | ) |

Returns the AsyncTaskChain on which this task will be running.

Each task chain runs tasks independently of the others.

long int getTaskId | ( |  | ) |

Returns a number guaranteed to be unique for each different AsyncTask object in the universe.

double getWakeTime | ( |  | ) |

If this task has been added to an AsyncTaskManager with a delay in effect, this returns the time at which the task is expected to awaken.

It has no meaning if the task has not yet been added to a queue, or if there was no delay in effect at the time the task was added.

If the task's status is not S_sleeping, this returns 0.0.

bool hasDelay | ( |  | ) |

Returns true if a delay has been set for this task via set_delay(), or false otherwise.

bool isAlive | ( |  | ) |

Returns true if the task is currently active or sleeping on some task chain, meaning that it will be executed in its turn, or false if it is not active.

If the task has recently been removed while it is in the middle of execution, this will return false, because the task will not run again once it finishes.

output | ( | ostream | out | ) |

Outputs the Namable.

This function simply writes the name to the output stream; most Namable derivatives will probably redefine this.

Reimplemented from Namable.

recalcWakeTime | ( |  | ) |

If the task is currently sleeping on a task chain, this resets its wake time to the current time + get_delay().

It is as if the task had suddenly returned DS_again. The task will sleep for its current delay seconds before running again. This method may therefore be used to make the task wake up sooner or later than it would have otherwise.

If the task is not already sleeping, this method has no effect.

remove | ( |  | ) |

Removes the task from its active manager, if any, and makes the state S_inactive (or possible S_servicing_removed).

This is a no-op if the state is already S_inactive.

setDelay | ( | double | delay | ) |

Specifies the amount of time, in seconds, by which this task will be delayed after it has been added to the AsyncTaskManager.

At least the specified amount of time (and possibly more) will elapse before the task begins.

You may specify a delay of 0.0 to guarantee that the task will run in the next epoch following the one in which it is added.

Setting this value after the task has already been added will not affect the task's wake time; it will only affect the task if it is re-added to the queue in the future, for instance if the task returns DS_again. However, see recalc_wake_time() if you wish to apply the delay effect immediately.

setDoneEvent | ( | string | done_event | ) |

Sets the event name that will be triggered when the task finishes.

This should only be called before the task has been started, or after it has finished and before it is about to be restarted (i.e. when get_state() returns S_inactive).

setName | ( | string | name | ) |

Reimplemented from Namable.

setPriority | ( | int | priority | ) |

Specifies a priority value for this task.

In general, tasks with a higher priority value are executed before tasks with a lower priority value (but only for tasks with the same sort value).

Unlike the sort value, tasks with different priorities may execute at the same time, if the AsyncTaskManager has more than one thread servicing tasks.

Also see AsyncTaskChain.set_timeslice_priority(), which changes the meaning of this value. In the default mode, when the timeslice_priority flag is false, all tasks always run once per epoch, regardless of their priority values (that is, the priority controls the order of the task execution only, not the number of times it runs). On the other hand, if you set the timeslice_priority flag to true, then changing a task's priority has an effect on the number of times it runs.

setPythonObject | ( | PyObject | python_object | ) |

Specifies an arbitrary Python object that will be piggybacked on the task object.

setSort | ( | int | sort | ) |

Specifies a sort value for this task.

Within a given AsyncTaskManager, all of the tasks with a given sort value are guaranteed to be completed before any tasks with a higher sort value are begun.

To put it another way, two tasks might execute in parallel with each other only if they both have the same sort value. Tasks with a lower sort value are executed first.

This is different from the priority, which makes no such exclusion guarantees.

setTaskChain | ( | string | chain_name | ) |

Specifies the AsyncTaskChain on which this task will be running.

Each task chain runs tasks independently of the others.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties